globjects::AbstractState Class Referenceabstract

`#include <globjects/include/globjects/AbstractState.h>`

Inheritance diagram for globjects::AbstractState:

## Public Member Functions

virtual void | enable (gl::GLenum capability)=0
virtual void | disable (gl::GLenum capability)=0
virtual bool | isEnabled (gl::GLenum capability) const =0
virtual void | enable (gl::GLenum capability, int index)=0
virtual void | disable (gl::GLenum capability, int index)=0
virtual bool | isEnabled (gl::GLenum capability, int index) const =0
void | setEnabled (gl::GLenum capability, bool enabled)
void | setEnabled (gl::GLenum capability, int index, bool enabled)
void | blendColor (gl::GLfloat red, gl::GLfloat green, gl::GLfloat blue, gl::GLfloat alpha)
void | blendColor (const std::array< gl::GLfloat, 4 > &color)
void | blendFunc (gl::GLenum sFactor, gl::GLenum dFactor)
void | blendFuncSeparate (gl::GLenum srcRGB, gl::GLenum dstRGB, gl::GLenum srcAlpha, gl::GLenum dstAlpha)
void | clearColor (gl::GLfloat red, gl::GLfloat green, gl::GLfloat blue, gl::GLfloat alpha)
void | clearColor (const std::array< gl::GLfloat, 4 > &color)
void | clearDepth (gl::GLfloat depth)
void | clearStencil (gl::GLint s)
void | colorMask (gl::GLboolean red, gl::GLboolean green, gl::GLboolean blue, gl::GLboolean alpha)
void | colorMask (const std::array< gl::GLboolean, 4 > &mask)
void | cullFace (gl::GLenum mode)
void | depthFunc (gl::GLenum func)
void | depthMask (gl::GLboolean flag)
void | depthRange (gl::GLdouble nearVal, gl::GLdouble farVal)
void | depthRange (gl::GLfloat nearVal, gl::GLfloat farVal)
void | depthRange (const std::array< gl::GLfloat, 2 > &range)
void | frontFace (gl::GLenum winding)
void | logicOp (gl::GLenum opcode)
void | pixelStore (gl::GLenum pname, gl::GLboolean param)
void | pixelStore (gl::GLenum pname, gl::GLint param)
void | pixelStore (gl::GLenum pname, gl::GLfloat param)
void | pointParameter (gl::GLenum pname, gl::GLenum param)
void | pointSize (gl::GLfloat size)
void | polygonMode (gl::GLenum face, gl::GLenum mode)
void | polygonOffset (gl::GLfloat factor, gl::GLfloat units)
void | primitiveRestartIndex (gl::GLuint index)
void | provokingVertex (gl::GLenum provokeMode)
void | sampleCoverage (gl::GLfloat value, gl::GLboolean invert)
void | scissor (gl::GLint x, gl::GLint y, gl::GLsizei width, gl::GLsizei height)
void | scissor (const std::array< gl::GLint, 4 > &scissorBox)
void | stencilFunc (gl::GLenum func, gl::GLint ref, gl::GLuint mask)
void | stencilMask (gl::GLuint mask)
void | stencilOp (gl::GLenum stencilFail, gl::GLenum depthFail, gl::GLenum depthPass)
void | stencilFuncSeparate (gl::GLenum face, gl::GLenum func, gl::GLint ref, gl::GLuint mask)
void | stencilMaskSeparate (gl::GLenum face, gl::GLuint mask)
void | stencilOpSeparate (gl::GLenum face, gl::GLenum stencilFail, gl::GLenum depthFail, gl::GLenum depthPass)
virtual void | add (StateSetting *setting)=0
template<typename... Arguments>
void | set (void(*function)(Arguments...), Arguments... arguments)

## Member Function Documentation

## enable() [1/2]

virtual void globjects::AbstractState::enable | ( | gl::GLenum | capability | ) |

pure virtual

Implemented in globjects::State.

## disable() [1/2]

virtual void globjects::AbstractState::disable | ( | gl::GLenum | capability | ) |

pure virtual

Implemented in globjects::State.

## isEnabled() [1/2]

virtual bool globjects::AbstractState::isEnabled | ( | gl::GLenum | capability | ) | const

pure virtual

Implemented in globjects::State.

## enable() [2/2]

virtual void globjects::AbstractState::enable | ( | gl::GLenum | capability,
|  | int | index
| ) |  |

pure virtual

Implemented in globjects::State.

## disable() [2/2]

virtual void globjects::AbstractState::disable | ( | gl::GLenum | capability,
|  | int | index
| ) |  |

pure virtual

Implemented in globjects::State.

## isEnabled() [2/2]

virtual bool globjects::AbstractState::isEnabled | ( | gl::GLenum | capability,
|  | int | index
| ) |  | const

pure virtual

Implemented in globjects::State.

## setEnabled() [1/2]

void globjects::AbstractState::setEnabled | ( | gl::GLenum | capability,
|  | bool | enabled
| ) |  |

## setEnabled() [2/2]

void globjects::AbstractState::setEnabled | ( | gl::GLenum | capability,
|  | int | index,
|  | bool | enabled
| ) |  |

## blendColor() [1/2]

void globjects::AbstractState::blendColor | ( | gl::GLfloat | red,
|  | gl::GLfloat | green,
|  | gl::GLfloat | blue,
|  | gl::GLfloat | alpha
| ) |  |

## blendColor() [2/2]

void globjects::AbstractState::blendColor | ( | const std::array< gl::GLfloat, 4 > & | color | ) |

## blendFunc()

void globjects::AbstractState::blendFunc | ( | gl::GLenum | sFactor,
|  | gl::GLenum | dFactor
| ) |  |

## blendFuncSeparate()

void globjects::AbstractState::blendFuncSeparate | ( | gl::GLenum | srcRGB,
|  | gl::GLenum | dstRGB,
|  | gl::GLenum | srcAlpha,
|  | gl::GLenum | dstAlpha
| ) |  |

## clearColor() [1/2]

void globjects::AbstractState::clearColor | ( | gl::GLfloat | red,
|  | gl::GLfloat | green,
|  | gl::GLfloat | blue,
|  | gl::GLfloat | alpha
| ) |  |

## clearColor() [2/2]

void globjects::AbstractState::clearColor | ( | const std::array< gl::GLfloat, 4 > & | color | ) |

## clearDepth()

void globjects::AbstractState::clearDepth | ( | gl::GLfloat | depth | ) |

## clearStencil()

void globjects::AbstractState::clearStencil | ( | gl::GLint | s | ) |

## colorMask() [1/2]

void globjects::AbstractState::colorMask | ( | gl::GLboolean | red,
|  | gl::GLboolean | green,
|  | gl::GLboolean | blue,
|  | gl::GLboolean | alpha
| ) |  |

## colorMask() [2/2]

void globjects::AbstractState::colorMask | ( | const std::array< gl::GLboolean, 4 > & | mask | ) |

## cullFace()

void globjects::AbstractState::cullFace | ( | gl::GLenum | mode | ) |

## depthFunc()

void globjects::AbstractState::depthFunc | ( | gl::GLenum | func | ) |

## depthMask()

void globjects::AbstractState::depthMask | ( | gl::GLboolean | flag | ) |

## depthRange() [1/3]

void globjects::AbstractState::depthRange | ( | gl::GLdouble | nearVal,
|  | gl::GLdouble | farVal
| ) |  |

## depthRange() [2/3]

void globjects::AbstractState::depthRange | ( | gl::GLfloat | nearVal,
|  | gl::GLfloat | farVal
| ) |  |

## depthRange() [3/3]

void globjects::AbstractState::depthRange | ( | const std::array< gl::GLfloat, 2 > & | range | ) |

## frontFace()

void globjects::AbstractState::frontFace | ( | gl::GLenum | winding | ) |

## logicOp()

void globjects::AbstractState::logicOp | ( | gl::GLenum | opcode | ) |

## pixelStore() [1/3]

void globjects::AbstractState::pixelStore | ( | gl::GLenum | pname,
|  | gl::GLboolean | param
| ) |  |

## pixelStore() [2/3]

void globjects::AbstractState::pixelStore | ( | gl::GLenum | pname,
|  | gl::GLint | param
| ) |  |

## pixelStore() [3/3]

void globjects::AbstractState::pixelStore | ( | gl::GLenum | pname,
|  | gl::GLfloat | param
| ) |  |

## pointParameter()

void globjects::AbstractState::pointParameter | ( | gl::GLenum | pname,
|  | gl::GLenum | param
| ) |  |

## pointSize()

void globjects::AbstractState::pointSize | ( | gl::GLfloat | size | ) |

## polygonMode()

void globjects::AbstractState::polygonMode | ( | gl::GLenum | face,
|  | gl::GLenum | mode
| ) |  |

## polygonOffset()

void globjects::AbstractState::polygonOffset | ( | gl::GLfloat | factor,
|  | gl::GLfloat | units
| ) |  |

## primitiveRestartIndex()

void globjects::AbstractState::primitiveRestartIndex | ( | gl::GLuint | index | ) |

## provokingVertex()

void globjects::AbstractState::provokingVertex | ( | gl::GLenum | provokeMode | ) |

## sampleCoverage()

void globjects::AbstractState::sampleCoverage | ( | gl::GLfloat | value,
|  | gl::GLboolean | invert
| ) |  |

## scissor() [1/2]

void globjects::AbstractState::scissor | ( | gl::GLint | x,
|  | gl::GLint | y,
|  | gl::GLsizei | width,
|  | gl::GLsizei | height
| ) |  |

## scissor() [2/2]

void globjects::AbstractState::scissor | ( | const std::array< gl::GLint, 4 > & | scissorBox | ) |

## stencilFunc()

void globjects::AbstractState::stencilFunc | ( | gl::GLenum | func,
|  | gl::GLint | ref,
|  | gl::GLuint | mask
| ) |  |

## stencilMask()

void globjects::AbstractState::stencilMask | ( | gl::GLuint | mask | ) |

## stencilOp()

void globjects::AbstractState::stencilOp | ( | gl::GLenum | stencilFail,
|  | gl::GLenum | depthFail,
|  | gl::GLenum | depthPass
| ) |  |

## stencilFuncSeparate()

void globjects::AbstractState::stencilFuncSeparate | ( | gl::GLenum | face,
|  | gl::GLenum | func,
|  | gl::GLint | ref,
|  | gl::GLuint | mask
| ) |  |

## stencilMaskSeparate()

void globjects::AbstractState::stencilMaskSeparate | ( | gl::GLenum | face,
|  | gl::GLuint | mask
| ) |  |

## stencilOpSeparate()

void globjects::AbstractState::stencilOpSeparate | ( | gl::GLenum | face,
|  | gl::GLenum | stencilFail,
|  | gl::GLenum | depthFail,
|  | gl::GLenum | depthPass
| ) |  |

## add()

virtual void globjects::AbstractState::add | ( | StateSetting * | setting | ) |

pure virtual

Implemented in globjects::State.

## set()

template<typename... Arguments>

void globjects::AbstractState::set | ( | void(*)(Arguments...) | function,
|  | Arguments... | arguments
| ) |  |

The documentation for this class was generated from the following file:

- AbstractState.h